<template>
  <div>
    <h3 class="h4 mb-3">Paiement</h3>

    <b-form-group>
      <b-card class="mb-2" v-for="mp in jsonMP" :key="mp.id">
        <div class="d-flex align-items-center">
          <b-form-radio name="some-radios" :value="mp.type" v-model="selectedPayment"
            ><strong>{{ mp.name }}</strong></b-form-radio
          >
          <div class="ml-auto" v-if="mp.logo !== ''">
            <img class="ml-auto" :src="require('../../assets/img/banque/' + mp.logo + '.png')" :alt="mp.name" />
          </div>
        </div>
      </b-card>
    </b-form-group>

    <div class="payment-methods mb-4">
      <h6 class="mb-2"><font-awesome-icon icon="lock" /> Paiement sécurisé</h6>
      <p class="lh-sm">
        <small
          >Seules les modalités de paiement indiquées ci-dessous sont valables.<br />
          Le paiement sécurisé exclu le paiement par chèque.</small
        >
      </p>
      <div class="">
        <img src="../../assets/img/e-commerce/iconmonstr-paypal-8.svg" alt="PayPal" />
        <img src="../../assets/img/e-commerce/iconmonstr-payment-1.svg" alt="Américan Express" />
        <img src="../../assets/img/e-commerce/iconmonstr-payment-3.svg" alt="Visa" />
        <img src="../../assets/img/e-commerce/iconmonstr-payment-5.svg" alt="Master card" />
        <img src="../../assets/img/e-commerce/iconmonstr-credit-card-5.svg" alt="Carte bleue" />
        <img src="../../assets/img/e-commerce/iconmonstr-debit-2.svg" alt="Chèque" />
      </div>
    </div>

    <b-button block variant="primary" @click="submitCart()" v-if="cartStore.cgv && cartStore.politique">Procéder au paiement</b-button>
    <b-button block variant="primary" disabled v-else>Procéder au paiement</b-button>
  </div>
</template>
<script>
import { mapState } from "vuex";
import jsonMP from "@/config-data/config-paiement.json";
export default {
  computed: {
    ...mapState({
      cartStore: state => state.cartStore,
      clientStore: state => state.clientStore
    })
  },
  mounted: function() {
    this.loadPaiementsModes();
  },
  data() {
    return {
      selectedPayment: null,
      jsonMP
    };
  },
  methods: {
    loadPaiementsModes() {
      this.jsonMP = this.jsonMP.filter(mp => {
        return mp.actif == true;
      });
      console.log("jsonMP", this.jsonMP);
    },
    async submitCart() {
      // vérifier les infos client
      // vérifier les infos du caddie
      // faire afficher le bon mode de paiement
      console.log("selectedPayment", this.selectedPayment);
      // TODO: mettre un loader
      await this.storeTransaction();
      // enregistrer en base la commande client
      // vider les store caddie et client
      // retourner un message de validation
    },
    async storeTransaction() {
      console.log("je dois enregistrer en bdd");
      // initialisation payload
      let payload = {
        name: this.clientStore.infoClient.name,
        idclient: this.clientStore.infoClient.id,
        reference: this.cartStore.idCart,
        data: {
          client: this.clientStore.infoClient,
          cart: this.cartStore
        }
      };
      console.log("to store", payload);
      // enregistrement en base (commenté temporairement)
      this.$axios
        .post(this.$urls.URL_STORE_TRANSACTION, payload)
        .then(response => {
          console.log("reponse panier", "response.data");
          // this.$store.dispatch("setUserObject", userObj);
          this.$store.dispatch("resetCart");
        })
        .catch(error => {
          console.log("error", error);
        });
    }
  }
};
</script>
